
#property copyright "Copyright 2016, AVG-Soft"
#property link      "http://mql5.com"

#property strict


extern double LotStart = 0.1;
extern int TakeProfit_ = 300;
extern int StopLoss_ = 200;
extern double Multiplier = 2.0;
extern double Multiplier2 = 2.0; //   
extern bool fFirst=true;  //=true -     , = false -  
extern int StepSL = 100; //   - ()
extern int StepTP = 100; //    ()

extern double Risk = 0.0;
int Magic = 12345;
extern double SARstep = 0.02;
double SARMax = 0.2;
int lastTicket=-1;
int lastTicketRev=-1;
int CountLost=0;
double lastLot=0;
double lastLotRev=0;
int lastType=-1;
int Slip=15;
int Iter=3;

int init() {
   return (0);
}

int deinit() {
   return (0);
}

void OnTick()
{
   int lTmp;

   FillOrders(Magic);
   {  if (lastTicket==-1)
      {  lTmp = GetParabolic();
         if ((CountLost==0 && lTmp == 1) || (CountLost>0 && lastType==OP_SELL))
         {  OpenOrder(Symbol(), OP_BUY, GetLot(), Ask, -1, GetStopLoss(0), GetProfit(0), WindowExpertName(), Magic, 0, Lime);
            if (CountLost>0 && (fFirst || (!fFirst && CountLost>1)))
            {  if (lastLotRev==0)
                  lastLotRev=LotStart;
               else
                  lastLotRev=lastLotRev*Multiplier2;
               OpenOrder(Symbol(), OP_SELL, lastLotRev, Bid, -1, 0, 0, WindowExpertName(), Magic+1, 0, Red);
            }
         }
         if ((CountLost==0 && lTmp == -1) || (CountLost>0 && lastType==OP_BUY))
         {   OpenOrder(Symbol(), OP_SELL, GetLot(), Bid, -1, GetStopLoss(1), GetProfit(1), WindowExpertName(), Magic, 0, Red);
            if (CountLost>0 && (fFirst || (!fFirst && CountLost>1)))
            {  if (lastLotRev==0)
                  lastLotRev=LotStart;
               else
                  lastLotRev=lastLotRev*Multiplier2;
               OpenOrder(Symbol(), OP_BUY, lastLotRev, Ask, -1, 0, 0, WindowExpertName(), Magic+1, 0, Lime);
            }
         }
      }
   }
   return;
}//onTick


//----------------------------------------------------

double GetLot()//f0_5()
{
   double lLot = -1;
   double fMargin = AccountFreeMargin();
   double mReq = MarketInfo(Symbol(), MODE_MARGINREQUIRED);
   double lotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
//   double minLot = MarketInfo(Symbol(), MODE_MINLOT);
//   double maxlot_40 = MarketInfo(Symbol(), MODE_MAXLOT);
   if (CountLost==0)
   {   if (Risk <= 0.0) lLot = LotStart;
      else
      {  if (Risk < 100.0) 
            lLot = MathFloor(fMargin * Risk / 100.0 / mReq / lotStep) * lotStep;
         else
            lLot = MathFloor( fMargin/mReq / lotStep) * lotStep;
      }
      lastLotRev=0;
   }
   else
   {  if (fFirst)
         lLot=lastLot*Multiplier;
      else
      {  if (CountLost==1)
            lLot=lastLot;
         else
            lLot=lastLot*Multiplier;
      }
   }
   return (lLot);
}//GetLot

//----------------------------------------------------

double GetStopLoss(int orderType, double lPrice = -1.0)
{ 

if(StopLoss_==0)return(0);

 double fRes=0;
   if (lPrice <= 0.0)
   {  if (orderType == OP_BUY) lPrice=Ask;
      if (orderType == OP_SELL) lPrice=Bid;
   }

   if (orderType == OP_BUY) fRes= lPrice - (StopLoss_ + StepSL*CountLost)* Point;
   if (orderType == OP_SELL) fRes= lPrice + (StopLoss_ + StepSL*CountLost)* Point;
   
   return (NormalizeDouble(fRes,Digits));
}//GetStopLoss
//----------------------------------------------------
double GetProfit(int orderType, double lPrice = -1.0)
{ 
if(TakeProfit_==0)return(0);
 double fRes=0;
   if (lPrice <= 0.0)
   {  if (orderType == OP_BUY) lPrice=Ask;
      if (orderType == OP_SELL) lPrice=Bid;
   }

   if (orderType == OP_BUY) fRes= lPrice + (TakeProfit_ + StepTP*CountLost)* Point;
   if (orderType == OP_SELL) fRes= lPrice - (TakeProfit_ + StepTP*CountLost)* Point;
   
   return (NormalizeDouble(fRes,Digits));

}//GetProfit

//----------------------------------------------------
int GetParabolic()
{
   double lSar = iSAR(Symbol(), Period(), SARstep, SARMax, 1);
   double lC = iClose(Symbol(), Period(), 1);
   if (lC > lSar) return (1);
   if (lC < lSar) return (-1);
   return (0);
}//GetParabolic

//----------------------------------------------------

void FillOrders(int lmagic = 0)
{  string lSym;

   lSym=Symbol();
   int i = 0;

   if (lastTicket>0) // ,   
   {  if (OrderSelect(lastTicket, SELECT_BY_TICKET))
      { lastType=OrderType();
        if (OrderCloseTime()>0) //   
        {  if (OrderSwap()+OrderCommission()+OrderProfit()>0)
           {   CountLost=0;
               lastLot=0;
               lastLotRev=0;
           }
           else 
           {  CountLost++;
              lastLot=OrderLots();
           }
           lastTicket=-1;
           if(lastTicketRev>0)
           {  if (CloseOneOrder(lastTicketRev))
              {  lastTicketRev=-1;
              }
           }
        }
      }
      else
      {lastTicket=-1;
       CountLost=0;
       lastLot=0;
       lastType=-1;
       lastLotRev=0;
       if(lastTicketRev>0)
       {  if (CloseOneOrder(lastTicketRev))
          {  lastTicketRev=-1;
          }
       }
      }
   }
   else
   {   for (i = OrdersTotal(); i >= 0; i--)
      {  if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
            if (OrderSymbol() == lSym)
               if (OrderMagicNumber() == lmagic && (OrderType()==OP_BUY || OrderType()==OP_SELL))
               { lastTicket=OrderTicket();
               }
               if (OrderMagicNumber() == lmagic+1 && (OrderType()==OP_BUY || OrderType()==OP_SELL))
               { lastTicketRev=OrderTicket();
                 lastLotRev=OrderLots();
               }
      }//for
      CountLost=0;
      lastLot=OrderLots();
      lastType=OrderType();
   }
   return;
}//FillOrders

//----------------------------------------------------

int OpenOrder(string lSymbol, int ordType, double lLot, double lPrice = -1.0, int lSlip = 15, double lSL = 0.0, double lTP = 0.0, string lComment = "", int lMagic = 0, datetime lDateExp = 0, color lColor = -1)
{
   bool fRes;
   double minlot;
   int ticket=-1;
   int err;
   string strLog = "";

   int lDigits = (int)MarketInfo(lSymbol, MODE_DIGITS);
   lSlip = 3;
   double lBid = MarketInfo(lSymbol, MODE_BID);
   if (lBid <= 0.0)
   {
      Print("OrderSend_::      " + lSymbol);
      return (-1);
   }
   if (ordType > OP_SELL)
   {
      Print("OrderSend_::    " + IntegerToString(ordType));
      return (-1);
   }
   for (int i = 1; i <= 3; i++)
   {
      while (!IsTradeAllowed()) Sleep(3000);
      fRes = FALSE;
      lLot = MathAbs(lLot);
      while (AccountFreeMarginCheck(lSymbol, ordType, lLot) <= 0.0 && GetLastError() == 134/* NOT_ENOUGH_MONEY */)
      {
         lLot -= MarketInfo(lSymbol, MODE_LOTSTEP);
         fRes = TRUE;
      }
      if (fRes)
      {
         minlot = MarketInfo(lSymbol, MODE_MINLOT);
         if (lLot < minlot) {
            strLog = StringConcatenate("OrderSendMarket():          (", NormalizeDouble(minlot, 2), ")");
            Print(strLog);
            return (-1);
         }
         strLog = StringConcatenate("OrderSendMarket():       (", NormalizeDouble(lLot, 2), ") -    !");
         Print(strLog);
      }
      lLot = CheckLot(lLot, lSymbol);
      ticket = -1;
      RefreshRates();
      if (ordType == OP_BUY) {
         lPrice = MarketInfo(lSymbol, MODE_ASK);
         if (lColor==clrNONE) lColor = Green;
      }
      if (ordType == OP_SELL) {
         lPrice = MarketInfo(lSymbol, MODE_BID);
         if (lColor==clrNONE) lColor = Red;
      }
      lPrice = NormalizeDouble(lPrice, Digits);
      GetLastError();
      ticket = OrderSend(lSymbol, ordType, lLot, lPrice, lSlip, lSL, lTP, lComment, lMagic, lDateExp, lColor);
      err = GetLastError();
      if (ticket < 0 || err > 0/* NO_ERROR */)
      {
         strLog = StringConcatenate("OrderSendMarket():    ", err, ":", DescribeError(err), ",  #", i, ".  : " +
            DoubleToStr(AccountFreeMargin(), 2) + ", . " + DoubleToStr(lLot * MarketInfo(lSymbol, MODE_MARGINREQUIRED), 2) + ".  : symbol=", lSymbol,
            " | Bid=", MarketInfo(lSymbol, MODE_BID), " | Ask=", MarketInfo(lSymbol, MODE_ASK), " | cmd=", GetTypeOrder(ordType), " | volume=", ConvertToStr(lLot, 2), " | stoploss=",
            ConvertToStr(lSL, lDigits), " | takeprofit=", ConvertToStr(lTP, lDigits), " | magic=", lMagic, " | comment=", lComment);
         Print(strLog);
         if (CheckError(err, ticket)) continue;
         strLog = StringConcatenate("OrderSendMarket():    ", err, ":", DescribeError(err));
         Print(strLog);
      } else
      {
         strLog = StringConcatenate(" ", ticket, "   c ", i, "- !  : " + DoubleToStr(AccountFreeMargin(), 2) + ", . " +
            DoubleToStr(lLot * MarketInfo(lSymbol, MODE_MARGINREQUIRED), 2) + ".  : symbol=", lSymbol, " | cmd=", GetTypeOrder(ordType), " | volume=", ConvertToStr(lLot,
            2), " | stoploss=", ConvertToStr(lSL, lDigits), " | takeprofit=", ConvertToStr(lTP, lDigits), " | magic=", lMagic, " | comment=", lComment);
         Print(strLog);
         if (lMagic==Magic)
            lastTicket=ticket;
         else
            lastTicketRev=ticket;
         break;
      }
   }//for
   return (ticket);
}
//-----------------------------------------------------
int CheckError(int numError, int ordTicket)
{
   if (numError == 2 || numError == 64 || numError == 65 || numError == 133) return (0);
   if (numError == 4 || numError == 131 || numError == 132)
   {
      Sleep(300000);
      return (0);
   }
   if (numError == 128 || numError == 142 || numError == 143)
   {
      Sleep(60000);
      if (!(OrderSelect(ordTicket, SELECT_BY_TICKET))) return (0);
      if (OrderCloseTime() != 0) return (0);
      return (1);
   }
   if (numError == 140 || numError == 148 || numError == 4110 || numError == 4111) return (0);
   if (numError == 141)
   {
      Sleep(100000);
      return (1);
   }
   if (numError == 145)
   {
      Sleep(17000);
      return (1);
   }
   if (numError == 146)
   {
      while (IsTradeContextBusy()) Sleep(11000);
      return (1);
   }
   if (numError != 135)
   {
      Sleep(7700.0);
      return (1);
   }
   return (1);
}//CheckError
//------------------------------------------------
string ConvertToStr(double lPrice, int lDigits = -1)
{
   if (lDigits < 0) return (DoubleToStr(lPrice, Digits));
   return (DoubleToStr(lPrice, lDigits));
}//ConvertToStr
//------------------------------------------------
string DescribeError(int numError, int lLang = 0)
{
   string retMessage;
   string erMessage[94];
   if (lLang == 0) {
      erMessage[0] = " ";
      erMessage[1] = " ,   ";
      erMessage[2] = " ";
      erMessage[3] = " ";
      erMessage[4] = "  ";
      erMessage[5] = "   ";
      erMessage[6] = "    ";
      erMessage[7] = " ";
      erMessage[8] = "  ";
      erMessage[9] = "    ";
      erMessage[10] = " ";
      erMessage[11] = "  ";
      erMessage[12] = "    ";
      erMessage[13] = " ";
      erMessage[14] = " ";
      erMessage[15] = " ";
      erMessage[16] = " ";
      erMessage[17] = " ";
      erMessage[18] = "    ";
      erMessage[19] = " ";
      erMessage[20] = " ";
      erMessage[21] = " ";
      erMessage[22] = " ";
      erMessage[23] = "    ";
      erMessage[24] = "  ";
      erMessage[25] = "  ";
      erMessage[26] = " ,       ";
      erMessage[27] = "  ";
      erMessage[28] = "     ";
      erMessage[29] = "      ,  ";
      erMessage[30] = "        ,   ";
      erMessage[31] = "         FIFO";
      erMessage[32] = " ";
      erMessage[33] = "  ";
      erMessage[34] = "  -  ";
      erMessage[35] = "    ";
      erMessage[36] = "    ";
      erMessage[37] = "      ";
      erMessage[38] = "    ";
      erMessage[39] = "    ";
      erMessage[40] = " ";
      erMessage[41] = "   ";
      erMessage[42] = "    ";
      erMessage[43] = "  ";
      erMessage[44] = "    ";
      erMessage[45] = "  ";
      erMessage[46] = " ";
      erMessage[47] = " ";
      erMessage[48] = " ";
      erMessage[49] = " DLL  ";
      erMessage[50] = "  ";
      erMessage[51] = "  ";
      erMessage[52] = "     ";
      erMessage[53] = "   ,   ";
      erMessage[54] = " ";
      erMessage[55] = "   ";
      erMessage[56] = "   ";
      erMessage[57] = "   ";
      erMessage[58] = " ";
      erMessage[59] = "  -";
      erMessage[60] = "  ";
      erMessage[61] = " ";
      erMessage[62] = "   ";
      erMessage[63] = "   ";
      erMessage[64] = "     ";
      erMessage[65] = "  ";
      erMessage[66] = "  ";
      erMessage[67] = "   string";
      erMessage[68] = "   integer";
      erMessage[69] = "   double";
      erMessage[70] = "    ";
      erMessage[71] = "     ";
      erMessage[72] = "    ";
      erMessage[73] = " ";
      erMessage[74] = "    ";
      erMessage[75] = "  ";
      erMessage[76] = "   ";
      erMessage[77] = "  ";
      erMessage[78] = "    ";
      erMessage[79] = "    ";
      erMessage[80] = " ";
      erMessage[81] = "     ";
      erMessage[82] = "  ";
      erMessage[83] = "  .    <    >   .";
      erMessage[84] = "   .    ";
      erMessage[85] = "   .    ";
      erMessage[86] = "  ";
      erMessage[87] = "   ";
      erMessage[88] = "  ";
      erMessage[89] = "  ";
      erMessage[90] = "  ";
      erMessage[91] = "  ";
      erMessage[92] = "   ";
      erMessage[93] = "    ";
   } else {
      if (lLang == 1) {
         erMessage[0] = "unknown error";
         erMessage[1] = "no error";
         erMessage[2] = "common error";
         erMessage[3] = "invalid trade parameters";
         erMessage[4] = "trade server is busy";
         erMessage[5] = "old version of the client terminal";
         erMessage[6] = "no connection with trade server";
         erMessage[7] = "not enough rights";
         erMessage[8] = "too frequent requests";
         erMessage[9] = "malfunctional trade operation (never returned error)";
         erMessage[10] = "account disabled";
         erMessage[11] = "invalid account";
         erMessage[12] = "trade timeout";
         erMessage[13] = "invalid price";
         erMessage[14] = "invalid stops";
         erMessage[15] = "invalid trade volume";
         erMessage[16] = "market is closed";
         erMessage[17] = "trade is disabled";
         erMessage[18] = "not enough money";
         erMessage[19] = "price changed";
         erMessage[20] = "off quotes";
         erMessage[21] = "broker is busy (never returned error)";
         erMessage[22] = "requote";
         erMessage[23] = "order is locked";
         erMessage[24] = "long positions only allowed";
         erMessage[25] = "too many requests";
         erMessage[26] = "modification denied because order too close to market";
         erMessage[27] = "trade context is busy";
         erMessage[28] = "expirations are denied by broker";
         erMessage[29] = "amount of open and pending orders has reached the limit";
         erMessage[30] = "hedging is prohibited";
         erMessage[31] = "prohibited by FIFO rules";
         erMessage[32] = "no error (never generated code)";
         erMessage[33] = "wrong function pointer";
         erMessage[34] = "array index is out of range";
         erMessage[35] = "no memory for function call stack";
         erMessage[36] = "recursive stack overflow";
         erMessage[37] = "not enough stack for parameter";
         erMessage[38] = "no memory for parameter string";
         erMessage[39] = "no memory for temp string";
         erMessage[40] = "not initialized string";
         erMessage[41] = "not initialized string in array";
         erMessage[42] = "no memory for array\' string";
         erMessage[43] = "too long string";
         erMessage[44] = "remainder from zero divide";
         erMessage[45] = "zero divide";
         erMessage[46] = "unknown command";
         erMessage[47] = "wrong jump (never generated error)";
         erMessage[48] = "not initialized array";
         erMessage[49] = "dll calls are not allowed";
         erMessage[50] = "cannot load library";
         erMessage[51] = "cannot call function";
         erMessage[52] = "expert function calls are not allowed";
         erMessage[53] = "not enough memory for temp string returned from function";
         erMessage[54] = "system is busy (never generated error)";
         erMessage[55] = "invalid function parameters count";
         erMessage[56] = "invalid function parameter value";
         erMessage[57] = "string function internal error";
         erMessage[58] = "some array error";
         erMessage[59] = "incorrect series array using";
         erMessage[60] = "custom indicator error";
         erMessage[61] = "arrays are incompatible";
         erMessage[62] = "global variables processing error";
         erMessage[63] = "global variable not found";
         erMessage[64] = "function is not allowed in testing mode";
         erMessage[65] = "function is not confirmed";
         erMessage[66] = "send mail error";
         erMessage[67] = "string parameter expected";
         erMessage[68] = "integer parameter expected";
         erMessage[69] = "double parameter expected";
         erMessage[70] = "array as parameter expected";
         erMessage[71] = "requested history data in update state";
         erMessage[72] = "    ";
         erMessage[73] = "end of file";
         erMessage[74] = "some file error";
         erMessage[75] = "wrong file name";
         erMessage[76] = "too many opened files";
         erMessage[77] = "cannot open file";
         erMessage[78] = "incompatible access to a file";
         erMessage[79] = "no order selected";
         erMessage[80] = "unknown symbol";
         erMessage[81] = "invalid price parameter for trade function";
         erMessage[82] = "invalid ticket";
         erMessage[83] = "trade is not allowed in the expert properties";
         erMessage[84] = "longs are not allowed in the expert properties";
         erMessage[85] = "shorts are not allowed in the expert properties";
         erMessage[86] = "object is already exist";
         erMessage[87] = "unknown object property";
         erMessage[88] = "object is not exist";
         erMessage[89] = "unknown object type";
         erMessage[90] = "no object name";
         erMessage[91] = "object coordinates error";
         erMessage[92] = "no specified subwindow";
         erMessage[93] = "    ";
      }
   }
   switch (numError) {
   case 0:
   case 1:
      retMessage = erMessage[1];
      break;
   case 2:
      retMessage = erMessage[2];
      break;
   case 3:
      retMessage = erMessage[3];
      break;
   case 4:
      retMessage = erMessage[4];
      break;
   case 5:
      retMessage = erMessage[5];
      break;
   case 6:
      retMessage = erMessage[6];
      break;
   case 7:
      retMessage = erMessage[7];
      break;
   case 8:
      retMessage = erMessage[8];
      break;
   case 9:
      retMessage = erMessage[9];
      break;
   case 64:
      retMessage = erMessage[10];
      break;
   case 65:
      retMessage = erMessage[11];
      break;
   case 128:
      retMessage = erMessage[12];
      break;
   case 129:
      retMessage = erMessage[13];
      break;
   case 130:
      retMessage = erMessage[14];
      break;
   case 131:
      retMessage = erMessage[15];
      break;
   case 132:
      retMessage = erMessage[16];
      break;
   case 133:
      retMessage = erMessage[17];
      break;
   case 134:
      retMessage = erMessage[18];
      break;
   case 135:
      retMessage = erMessage[19];
      break;
   case 136:
      retMessage = erMessage[20];
      break;
   case 137:
      retMessage = erMessage[21];
      break;
   case 138:
      retMessage = erMessage[22];
      break;
   case 139:
      retMessage = erMessage[23];
      break;
   case 140:
      retMessage = erMessage[24];
      break;
   case 141:
      retMessage = erMessage[25];
      break;
   case 145:
      retMessage = erMessage[26];
      break;
   case 146:
      retMessage = erMessage[27];
      break;
   case 147:
      retMessage = erMessage[28];
      break;
   case 148:
      retMessage = erMessage[29];
      break;
   case 149:
      retMessage = erMessage[30];
      break;
   case 150:
      retMessage = erMessage[31];
      break;
   case 4000:
      retMessage = erMessage[32];
      break;
   case 4001:
      retMessage = erMessage[33];
      break;
   case 4002:
      retMessage = erMessage[34];
      break;
   case 4003:
      retMessage = erMessage[35];
      break;
   case 4004:
      retMessage = erMessage[36];
      break;
   case 4005:
      retMessage = erMessage[37];
      break;
   case 4006:
      retMessage = erMessage[38];
      break;
   case 4007:
      retMessage = erMessage[39];
      break;
   case 4008:
      retMessage = erMessage[40];
      break;
   case 4009:
      retMessage = erMessage[41];
      break;
   case 4010:
      retMessage = erMessage[42];
      break;
   case 4011:
      retMessage = erMessage[43];
      break;
   case 4012:
      retMessage = erMessage[44];
      break;
   case 4013:
      retMessage = erMessage[45];
      break;
   case 4014:
      retMessage = erMessage[46];
      break;
   case 4015:
      retMessage = erMessage[47];
      break;
   case 4016:
      retMessage = erMessage[48];
      break;
   case 4017:
      retMessage = erMessage[49];
      break;
   case 4018:
      retMessage = erMessage[50];
      break;
   case 4019:
      retMessage = erMessage[51];
      break;
   case 4020:
      retMessage = erMessage[52];
      break;
   case 4021:
      retMessage = erMessage[53];
      break;
   case 4022:
      retMessage = erMessage[54];
      break;
   case 4050:
      retMessage = erMessage[55];
      break;
   case 4051:
      retMessage = erMessage[56];
      break;
   case 4052:
      retMessage = erMessage[57];
      break;
   case 4053:
      retMessage = erMessage[58];
      break;
   case 4054:
      retMessage = erMessage[59];
      break;
   case 4055:
      retMessage = erMessage[60];
      break;
   case 4056:
      retMessage = erMessage[61];
      break;
   case 4057:
      retMessage = erMessage[62];
      break;
   case 4058:
      retMessage = erMessage[63];
      break;
   case 4059:
      retMessage = erMessage[64];
      break;
   case 4060:
      retMessage = erMessage[65];
      break;
   case 4061:
      retMessage = erMessage[66];
      break;
   case 4062:
      retMessage = erMessage[67];
      break;
   case 4063:
      retMessage = erMessage[68];
      break;
   case 4064:
      retMessage = erMessage[69];
      break;
   case 4065:
      retMessage = erMessage[70];
      break;
   case 4066:
      retMessage = erMessage[71];
      break;
   case 4067:
      retMessage = erMessage[72];
      break;
   case 4099:
      retMessage = erMessage[73];
      break;
   case 4100:
      retMessage = erMessage[74];
      break;
   case 4101:
      retMessage = erMessage[75];
      break;
   case 4102:
      retMessage = erMessage[76];
      break;
   case 4103:
      retMessage = erMessage[77];
      break;
   case 4104:
      retMessage = erMessage[78];
      break;
   case 4105:
      retMessage = erMessage[79];
      break;
   case 4106:
      retMessage = erMessage[80];
      break;
   case 4107:
      retMessage = erMessage[81];
      break;
   case 4108:
      retMessage = erMessage[82];
      break;
   case 4109:
      retMessage = erMessage[83];
      break;
   case 4110:
      retMessage = erMessage[84];
      break;
   case 4111:
      retMessage = erMessage[85];
      break;
   case 4200:
      retMessage = erMessage[86];
      break;
   case 4201:
      retMessage = erMessage[87];
      break;
   case 4202:
      retMessage = erMessage[88];
      break;
   case 4203:
      retMessage = erMessage[89];
      break;
   case 4204:
      retMessage = erMessage[90];
      break;
   case 4205:
      retMessage = erMessage[91];
      break;
   case 4206:
      retMessage = erMessage[92];
      break;
   case 4207:
      retMessage = erMessage[93];
      break;
   default:
      retMessage = erMessage[0];
   }
   return (retMessage);
}//DescribeError
//----------------------------------------------
double CheckLot(double lLot, string lSymbol = "0") {
   if (lSymbol == "0") lSymbol = Symbol();
   double lotRes = -1.0;
   double lMinLot = MarketInfo(lSymbol, MODE_MINLOT);
   double lMaxLot = MarketInfo(lSymbol, MODE_MAXLOT);
   double lotstep = MarketInfo(lSymbol, MODE_LOTSTEP);
   double lTmp = 0.0;
   if (lotstep != 0.0) lTmp = 1 / lotstep;
   else lTmp = 1 / lMinLot;
   lotRes = MathFloor(lLot * lTmp) / lTmp;
   if (lotRes < lMinLot) lotRes = lMinLot;
   if (lotRes > lMaxLot) lotRes = lMaxLot;
   return (lotRes);
}//CheckLot

//---------------------------------------------
string GetTypeOrder(int typeOrd)
{
   switch (typeOrd) {
   case 0:
      return ("OP_BUY");
   case 1:
      return ("OP_SELL");
   case 2:
      return ("OP_BUYLIMIT");
   case 3:
      return ("OP_SELLLIMIT");
   case 4:
      return ("OP_BUYSTOP");
   case 5:
      return ("OP_SELLSTOP");
   }
   return ("Unknown command!");
}//GetTypeOrder

//+------------------------------------------------------------------+
bool CloseOneOrder(int tOrder)
{//     tOrder
   int j;
   double curPrice=0, lotClose;
   bool fRes=false;
   
   if (!OrderSelect(tOrder, SELECT_BY_TICKET))
   { Print("Order ",tOrder," -     = ",GetLastError() );
     return(false);
   }
   RefreshRates();
   if (OrderType()==OP_BUY)
      curPrice=Bid;
   if (OrderType()==OP_SELL)
      curPrice=Ask;
   
   lotClose=OrderLots();
   j=0;
   while (OrderClose(tOrder,lotClose,curPrice,Slip,clrGreen)==false && j<Iter)
   { Print("Order ",tOrder," -   = ",GetLastError() );
     j++;
     RefreshRates();
     if (OrderType()==OP_BUY)
        curPrice=Bid;
     if (OrderType()==OP_SELL)
        curPrice=Ask;
   }// while 
   if (j==Iter)
     Print("      Order ",tOrder);
   else { Print("Order ",tOrder, " -    =",DoubleToString(lotClose,3)); fRes=true;}
   
   return(fRes);

}//CloseOneOrder
